/**
 *
 */
package de.intevation.gnv.state;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.apache.log4j.Logger;

import de.intevation.gnv.geobackend.base.Result;
import de.intevation.gnv.state.describedata.DefaultMinMaxDescribeData;
import de.intevation.gnv.state.describedata.DescribeData;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 * 
 */
public class MinMaxState extends StateBase {

    /**
     * The UID of this Class
     */
    private static final long serialVersionUID = -3525903792105187408L;
    /**
     * the logger, used to log exceptions and additonaly information
     */
    private static Logger log = Logger.getLogger(MinMaxState.class);

    /**
     * Constructor
     */
    public MinMaxState() {
        super();
    }

    /**
     * @see de.intevation.gnv.state.StateBase#purifyResult(java.util.Collection,
     *      java.lang.String)
     */
    @Override
    protected void purifyResult(Collection<Result> result, String uuid) {
        log.debug("MinMaxState.purifyResult");
        List<Object> describeData = this.getDescibeData(uuid);
        if (describeData == null) {
            describeData = new ArrayList<Object>();
        }
        if (result != null && result.size() == 1) {
            
            Result value = result.iterator().next();
            DescribeData values = new DefaultMinMaxDescribeData(this.dataName, 
                                                               value.getObject("MIN"), 
                                                               value.getObject("MAX"));
            log.debug(values.toString());
            describeData.add(values);
        } else {
            log.warn("Result cannot be handled as MinMax Resultset");
        }
        this.setDescibeData(uuid, describeData);
    }

}
